Attribute VB_Name = "FilterDLL"
'# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
'#                                                                                                   #
'#  filter.dll          Version 1.0.0.0                                                              #
'#  Gebastelt von       Onkl Doc alias Michael Schneider 2008                                        #
'#  Internet            http://www.djdoc.de                                                          #
'#                                                                                                   #
'#  WaveInStart         -> Diese Funktion muss zuerst aufgerufen werden                              #
'#      hWnd            -> z.B. hWnd des eures Fensters                                              #
'#      SamplesPerSec   -> Samplingfrequenz der Soundkarte                      Standart = 44100     #
'#      Channels        -> 0=Stereo, 1=Linker Kanal, 2=Rechter Kanal            Standart = 0         #
'#      CallbackPerSec  -> Anzahl der Aufrufe der "VBCallback()" pro Sekunde    Standart = 50        #
'#                                                                                                   #
'#  WaveInStop          -> Bricht alles ab und lscht alle eingestellten Werte                       #
'#                      -> Aufruft ist nicht zwinged erforderlicht, da die DLL bei Programmende      #
'#                         automatisch die Aufnahme beendet                                          #
'#                                                                                                   #
'#  SetVBCallback       -> Hiermit wird der DLL die Adresse der Rckruffunktion bergeben            #
'#                                                                                                   #
'#  SetFilter           -> Einen von bis zu 100 Filtern einstellen (0 bis 99)                        #
'#      FilterNr        -> Index (0 bis 99)                                                          #
'#      Channel         -> 0=Mono, 1=Linker Kanal, 2=Rechter Kanal                                   #
'#      Frequenz        -> Mittenfrequenz des Filters                                                #
'#      Bandbreite      -> Bandbreite in Oktaven                                                     #
'#                                                                                                   #
'#  SetLevelParam       -> Bereich und Geschwindigkeit der Anzeige einstellen                        #
'#                         (siehe Public Type LEVELPARAM)                                            #
'#                                                                                                   #
'#  GetStatus           -> Info ber den Arbeitszustand der DLL                                      #
'#      Idx=0           -> 0=Keine Aufnahme, 1=Aufnahme luft                                        #
'#      Idx=1           -> Zur Verfgungstehende Aufnahmepuffer in Prozent (sollte 100% sein )       #
'#                                                                                                   #
'#  GetLevel            -> Aktuelle Pegel abfragen                                                   #
'#      Typ             -> siehe "Public Enum LT"                                                    #
'#      FilterNum       -> Filter 0 bis 99 (nur bei LTFilter und LTFilterPeek                        #
'#                                                                                                   #
'#  Rckgabewert bei Fehlern aller Funktionen: -1                                                    #
'#                                                                                                   #
'# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
'WaveInStart Diese Funktion muss zuerst aufgerufen werden
Declare Function WaveInStart Lib "filter.dll" (ByVal hWnd As Long, Optional ByVal SamplesPerSec As Long = 44100, Optional ByVal Channels As Long = 2, Optional ByVal CallbackPerSec As Long = 50) As Long
Declare Sub WaveInStop Lib "filter.dll" ()
Declare Sub SetVBCallback Lib "filter.dll" (ByVal CallbackFunc As Long)
Declare Function SetFilter Lib "filter.dll" (ByVal FilterNr As Long, ByVal Channel As Long, ByVal Frequenz As Double, ByVal Bandbreite As Double) As Long
Declare Function SetLevelParam Lib "filter.dll" (LP As LEVELPARAM) As Long
Declare Function GetStatus Lib "filter.dll" (ByVal Idx As Long) As Long
Declare Function GetLevel Lib "filter.dll" (ByVal Typ As LT, ByVal FilterNum As Long) As Double

'long SetLevelParam(LEVELPARAM LevelParam)
Public Type LEVELPARAM
    LevelMin As Double      'kleinster Rckgabewert von GetLevel()
    LevelMax As Double      'grsster  Rckgabewert von GetLevel()
    Speed As Double         'Fallgeschwindigkeit der Level in dB pro Sekunde
    PeekTime As Double      'Haltezeit der Peek-Level in Sekunden
    PeekSpeed As Double     'Fallgeschwindigkeit der Peek-Level in dB pro Sekunde
End Type

Public Enum LT  'Fr GetLevel() - Ich glaube das erklrt sich von selbst
    LTMono = 0
    LTMonoPeek = 1
    LTLinks = 2
    LTLinksPeek = 3
    LTRechts = 4
    LTRechtsPeek = 5
    LTFilter = 6
    LTFilterPeek = 7
End Enum

Public LP As LEVELPARAM

'Diese Callback-Funktion wird von der DLL aufgerufen
'Hier knnt Ihr reinschreiben, was passieren soll
Sub VBCallback()
    '"On Error" solltet Ihr drin lassen. Euer PC kann sonst
    'gnadenlos abstrzen, wenn ein Programmierfehler drin ist
    On Error GoTo Fehler
    
    HF.PBBuf.Value = GetStatus(1)   'Pufferanzege
    HF.PBBuf.Refresh
    
'Die grnen Progressbars --------------------------------------------
    With LP
        .LevelMin = HF.PBA(0).Min   'niedrigster Pegel (in dB), der zurckgegeben wird
        .LevelMax = HF.PBA(0).Max   'hchster Pegel (in dB), der zurckgegeben wird
    End With
    SetLevelParam LP
    
    HF.PBL.Value = GetLevel(LTLinks, 0)         'Pegel fr links
    HF.PBR.Value = GetLevel(LTRechts, 0)        'Pegel fr rechts
    HF.PBM.Value = GetLevel(LTMono, 0)          'Mono-Pegel
    
    'Die 30 Bnder
    For n = 0 To 30
        HF.PBA(n).Value = GetLevel(LTFilter, n)
    Next

'Die roten Progressbars --------------------------------------------
    With LP
        .LevelMin = HF.PBAP(0).Min   'niedrigster Pegel (in dB), der zurckgegeben wird
        .LevelMax = HF.PBAP(0).Max   'hchster Pegel (in dB), der zurckgegeben wird
    End With
    SetLevelParam LP

    HF.PBPL.Value = GetLevel(LTLinks, 0)         'Pegel fr links
    HF.PBPR.Value = GetLevel(LTRechts, 0)        'Pegel fr rechts
    HF.PBPM.Value = GetLevel(LTMono, 0)          'Mono-Pegel
    
    'Die 30 Bnder
    For n = 0 To 30
        HF.PBAP(n).Value = GetLevel(LTFilter, n)
    Next

'Die Peek Progressbars --------------------------------------------
    With LP
        .LevelMin = HF.PBA(0).Min    'niedrigster Pegel (in dB), der zurckgegeben wird
        .LevelMax = HF.PBAP(0).Max   'hchster Pegel (in dB), der zurckgegeben wird
    End With
    SetLevelParam LP

    mul = (HF.PBA(0).Height + HF.PBAP(0).Height) / (HF.PBAP(0).Max - HF.PBA(0).Min)
    y0 = HF.PBA(0).Top + HF.PBA(0).Height - HF.PicPeek(0).Height + HF.PBA(0).Min * mul

    HF.PicPeekL.Top = y0 - GetLevel(LTLinksPeek, n) * mul
    HF.PicPeekR.Top = y0 - GetLevel(LTRechtsPeek, n) * mul
    HF.PicPeekM.Top = y0 - GetLevel(LTMonoPeek, n) * mul

    'Die 30 Bnder
    For n = 0 To 30
        HF.PicPeek(n).Top = y0 - GetLevel(LTFilterPeek, n) * mul
    Next

Exit Sub
Fehler: 'Tritt nur auf, wenn Ihr Scheisse programmiert habt
    Debug.Print "Fehler: " & Err.Number & " -> " & Err.Description
End Sub


